 # -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

import pyqtgraph as pg
from ADoutputs import daq_AO, daq_DO
from pyqtgraph.Qt import QtGui
from PyQt5.QtCore import QBasicTimer
from PyQt5.QtWidgets import (QPushButton, QWidget)


#An example of a class
class anal_control_signal(QWidget):

    def __init__(self, name, channel):
        super().__init__()
        self.name = name
        self.ch = channel
        
        self.initial_value = 0
        self.max = 10
        self.min = -10
        self.step = 0.1
        self.siPrefix = True
        self.suffix = 'V'

        self.sb = pg.SpinBox(value = self.initial_value, bounds=[self.min, self.max], step = self.step, siPrefix = self.siPrefix, suffix = self.suffix)
        
        self.AO = daq_AO(self.ch)
    
        self.scan_button = QPushButton('Start scan')
        
        self.timer = QBasicTimer()
        self.scan_step = 0

        self.scan_sb_start =  pg.SpinBox(value = 0, bounds=[self.min, self.max], step = self.step, siPrefix = self.siPrefix, suffix = self.suffix)
        self.scan_sb_stop =    pg.SpinBox(value = 0, bounds=[self.min, self.max], step = self.step, siPrefix = self.siPrefix, suffix = self.suffix)
        self.scan_sb_period = pg.SpinBox(value = 1, bounds=[0, 100], step = 0.1, siPrefix = True, suffix = 's')
        
        self.scan_direction = 0
        
        self.scan_button.clicked.connect(self.doAction)
        
    def set_name(self, name):
        self.name = name
    
    def set_initial_value(self, value):
        self.initial_value = value
        
    def set_max(self, value):
        self.max = value
    
    def set_min(self, value):
        self.min = value
        
    def set_step(self, value):
        self.step = value
    
    def set_siPrefix(self, value):
        self.siPrefix = value
    
    def set_sufix(self, value):
        self.sufix = value
    
   
        
    def timerEvent(self, e):
        if abs(abs(self.scan_step)-abs(float(self.scan_sb_start.val)))<1e-6 or abs(abs(self.scan_step)-abs(float(self.scan_sb_stop.val)))<1e-6:
            self.scan_direction = (-1) * self.scan_direction
            
        #print(self.scan_step, float(self.scan_sb_start.val), abs(self.scan_step-float(self.scan_sb_stop.val)))
        self.scan_step = self.scan_step + self.scan_direction
        self.AO.set_out(self.scan_step)
        

    def doAction(self):
        
        self.scan_direction = -float( (self.scan_sb_stop.val-self.scan_sb_start.val)/self.scan_sb_period.val ) * float(2 * 1e-3)
        self.scan_step = float(self.scan_sb_start.val)
        
        if self.timer.isActive():
            self.timer.stop()
            self.scan_button.setText('Start scan')
            self.scan_button.setStyleSheet('background-color: None')
            
            self.scan_step = 0
            self.AO.set_out(self.sb.val)
        else:
            self.scan_button.setStyleSheet("background-color: green")
            self.timer.start(1, self)
            self.scan_button.setText('Scanning')
            

    
        
        

            
class digital_control_signal(QWidget):
    
    def __init__(self, name, channel):
        self.name = name
        self.ch = channel
        
        self.initial_value = 0
        self.DO = daq_DO(self.ch)
        
        self.cb = QtGui.QCheckBox()
        
    def set_name(self, name):
        self.name = name
    
    def set_initial_value(self, value):
        self.initial_value = value
"""
class analog_scan:
    def __init__(self, signal):
        self.signal = signal
        self.sb_start =  pg.SpinBox(value = 0, bounds=[signal.min, signal.max], step = signal.step, siPrefix = signal.siPrefix, suffix = signal.suffix)
        self.sb_stop =    pg.SpinBox(value = 0, bounds=[signal.min, signal.max], step = signal.step, siPrefix = signal.siPrefix, suffix = signal.suffix)
        self.sb_period = pg.SpinBox(value = 1, bounds=[0, 100], step = 0.1, siPrefix = True, suffix = 's')
        self.cb = QtGui.QCheckBox()
        
        self.cb.stateChanged.connect(self.scan)
        
    def scan(self):
        
        ao = self.signal
        start, stop, period = self.sb_start.value(), self.sb_stop.value(), self.sb_period.value()
        
        
        dt = 1e-3
        n = period / (2*dt)
        voltages = np.linspace(start, stop, n)
        i = 0
        scanning = self.cb.isChecked()
        while(scanning):
            while( i<len(voltages)-1 ):
                ao.set_out(voltages[i])
                i = i + 1
                time.sleep(dt)
                while(i>0):
                    ao.set_out(voltages[i])
                    i = i - 1
                    time.sleep(dt)
            scanning = self.cb.isChecked()
"""